/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _DATABASE_H
#define _DATABASE_H

#include <GlanException.h>
#include <QtSql>

namespace Glan
{

class Database
{
   QString      ConnectionString;
   quint16      TransactionLevel;
   QSqlDatabase Connection;
   QString      CurrentSchema;
public:
   Database();
   ~Database();
   Database(const Database& other);
   Database& operator=(const Database& other);
   operator QSqlDatabase(){return Connection;}

   void setHostName(const QString& host){Connection.setHostName(host);}
   void setPort(int port){return Connection.setPort(port);}
   void setDatabaseName(const QString& name){Connection.setDatabaseName(name);}
   void setUserName(const QString& name){Connection.setUserName(name);}
   void setPassword(const QString password){Connection.setPassword(password);}

   QString databaseName(){return Connection.databaseName();}

   bool transaction();
   bool commit();
   bool rollback();
   void flushTransaction();
   void setCurrentSchema(const QString&);

   QString hostName()      const{return Connection.hostName();}
   int port()              const{return Connection.port();}
   QString databaseName()  const{return Connection.databaseName();}

   void recreateWorkSchema();
};

class Transaction
{
   Database *connection;
public:
   Transaction(Database*);
   ~Transaction();
};


}

#endif
