/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGABSTRACTBUTTON_H
#define GLAN_SERVERGABSTRACTBUTTON_H

#include <GWidget.h>
#include <GIcon.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GAbstractButton : public GWidget
{
   Q_OBJECT
   QString  ButtonText;
   bool     Checkable;
   bool     Checked;

protected:
   virtual void processEvent(const QXmlAttributes&);
public:
   GAbstractButton(GWidget*, bool final=FINAL);
   ~GAbstractButton();
   void setText(const QString&);


   QString text(){return ButtonText;}
   void setIcon ( const GIcon & icon );
   void setCheckable ( bool );
   void setChecked(bool);

   bool isCheckable () const{return Checkable;}
   bool isChecked()const {return Checked;}
signals:
   void clicked(bool checked=false);
   void pressed();
   void released();
   void toggled(bool checked);
};

}

}

#endif
