/***************************************************************************
 *   Copyright (c) 2004-2006 Oleg Shalnev                                  *
 *   Copyright (c) 2005-2006 OLMAX                                         *
 *   All rights reserved.                                                  *
 *   mailto:contact@kalpa.ru                                               *
 *   http://kalpa.ru                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGABSTRACTSPINBOX_H
#define GLAN_SERVERGABSTRACTSPINBOX_H

#include <GWidget.h>
#include <QValidator>

namespace Glan
{

namespace Server
{

/**
@author Oleg Shalnev
*/
class GAbstractSpinBox : public GWidget
{
    Q_OBJECT
protected:

    enum ButtonSymbols { UpDownArrows, PlusMinus };
    
    void initObject();
    void processEvent(const QXmlAttributes&);
    
public:
    GAbstractSpinBox(GWidget*,  const QString& uniqueId=QString::null, bool final=FINAL);
    ~GAbstractSpinBox();
    Qt::Alignment alignment () const;
    ButtonSymbols buttonSymbols () const;
    virtual void fixup ( QString & input ) const;
    bool hasFrame () const;
    void interpretText ();
    bool isReadOnly () const;
    void setAlignment ( Qt::Alignment flag );
    void setButtonSymbols ( ButtonSymbols bs );
    void setFrame ( bool );
    void setReadOnly ( bool r );
    void setSpecialValueText ( const QString & s );
    void setWrapping ( bool w );
    QString specialValueText () const;
    virtual void stepBy ( int steps );
    QString text () const;
    virtual QValidator::State validate ( QString & input, int & pos ) const;
    bool wrapping () const;
public slots:
    virtual void clear ();
    void selectAll ();
    void stepDown ();
    void stepUp ();
signals:
    void editingFinished ();
};

}

}

#endif
