/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGACTION_H
#define GLAN_SERVERGACTION_H

#include <QPointer>
#include <GObject.h>
#include <GFont.h>
#include <GIcon.h>
#include <GMenu.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GAction : public GObject
{
   Q_OBJECT
   QString  Text;
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   GObject           *ParentObject;
   bool              Separator;
   QString           StatusTip;
   bool              Checkable;
   bool              Checked;
   QPointer<GFont>   ActionFont;
   GIcon       ActionIcon;
   QPointer<GMenu>   ActionMenu;
public:
   GAction(GObject*, bool final=FINAL);
   GAction(const QString& text, GObject*, bool final=FINAL);
   ~GAction();
//   void setData ( const QVariant & data );
   void setFont(const GFont*);
   void setIcon ( const GIcon& icon );
   void setIconText ( const QString & text );
   void setMenu ( GMenu * menu );
   void setSeparator ( bool b );
   void setShortcut(const QString&);
   void setShortcutContext ( Qt::ShortcutContext context );
   void setStatusTip ( const QString & statusTip );
   void setText(const QString& );
   void setToolTip ( const QString & tip );
   void setWhatsThis ( const QString & what );
   void setCheckable ( bool );
   void setChecked ( bool );
  

   QString text(){return Text;}
   bool isSeparator () const{return Separator;}
   QString statusTip () const{return StatusTip;}
   bool isCheckable () const{return Checkable;}
   bool isChecked () const{return Checked;}
   GFont* font();
   GIcon icon(){return ActionIcon;}
   GMenu* menu(){return ActionMenu;}
signals:
   void changed ();
   void hovered ();
   void toggled ( bool checked );
   void triggered ( bool checked = false );
};

}
}

#endif
