/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGBOXLAYOUT_H
#define GLAN_SERVERGBOXLAYOUT_H

#include <GLayout.h>
#include <GSpacerItem.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GBoxLayout : public GLayout
{

public:
   enum Direction { LeftToRight, RightToLeft, TopToBottom, BottomToTop,
                    Down = TopToBottom, Up = BottomToTop };
protected:
   int Stretch;
   Direction LayoutDirection;


   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   GBoxLayout(Direction dir, GWidget *parent, bool final=FINAL);
   GBoxLayout(GWidget *parent, bool final=FINAL);
   ~GBoxLayout();
   void setDirection(Direction dir);
   void addLayout(GLayout*, int stretch=0);
   void addSpacing(int size);
   void addStretch(int stretch=0);
   void addStrut(int size);
   void addWidget(GWidget*, int stretch=0, Qt::Alignment alignment = 0 );
   void addItem(GSpacerItem*);
   void insertLayout(int index, GLayout *layout, int stretch=0);
   void insertSpacing(int index, int size);
   void insertStretch(int index, int stretch=0);
   void insertWidget(int index, GWidget* widget, int stretch=0, Qt::Alignment alignment=0);
   void invalidate();



   Direction direction(){return LayoutDirection;}
};

}

}

#endif
