/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGBRUSH_H
#define GLAN_SERVERGBRUSH_H

#include <GObject.h>
#include <QBrush>
#include <GColor.h>
#include <GPixmap.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GBrush : public GObject, public QBrush
{
protected:

   void initObject();
   virtual void processEvent(const QXmlAttributes&);

public:
   GBrush(bool final=FINAL);
   GBrush ( Qt::BrushStyle style,bool final=FINAL );
   GBrush ( const GColor & color, Qt::BrushStyle style = Qt::SolidPattern,bool final=FINAL );
   GBrush ( const GColor & color, const GPixmap & pixmap, bool final=FINAL );
   GBrush ( const GPixmap & pixmap, bool final=FINAL );
   GBrush ( const GBrush & other, bool final=FINAL );
   //GBrush ( const GGradient & gradient );
   GBrush ( Qt::GlobalColor color, Qt::BrushStyle style = Qt::SolidPattern, bool final=FINAL );
   GBrush ( Qt::GlobalColor color, const GPixmap & pixmap, bool final=FINAL );
   ~GBrush();

   void setColor ( const GColor & c );
   void setColor ( Qt::GlobalColor c );
   void setStyle ( Qt::BrushStyle style );
   void setTexture ( const GPixmap & pixmap );
};

}

}

#endif
