/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGDOCKWIDGET_H
#define GLAN_SERVERGDOCKWIDGET_H

#include <GWidget.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GDockWidget : public GWidget
{
   GWidget  *widgetInDock;
   bool     fl;
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   enum DockWidgetFeature {
      DockWidgetClosable    = 0x01,
      DockWidgetMovable     = 0x02,
      DockWidgetFloatable   = 0x04,

      DockWidgetFeatureMask = 0x07,
      AllDockWidgetFeatures = DockWidgetFeatureMask,
      NoDockWidgetFeatures  = 0x00,

      Reserved              = 0xff
   };



   GDockWidget(GWidget* parent=0, Qt::WFlags f=0, const QString& uniqueid=QString::null, bool final=FINAL);
   GDockWidget(const QString& title, GWidget* parent=0, Qt::WFlags f=0, const QString& uniqueid=QString::null, bool final=FINAL);
   ~GDockWidget();
   void setAllowedAreas ( Qt::DockWidgetAreas areas );
   void setFeatures ( int features );
   void setFloating ( bool floating );
   void setWidget ( GWidget * widget );
};

}
}

#endif
