/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGFONT_H
#define GLAN_SERVERGFONT_H

#include <GObject.h>
#include <QFont>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GFont : public GObject, public QFont
{

protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

public:
   GFont(bool final=FINAL);
   GFont(const GFont&);
   const GFont& operator=(const GFont&);
   ~GFont();


   //bool fromString ( const QString & descrip );
   void setBold ( bool enable );
   void setFamily ( const QString & family );
   void setFixedPitch ( bool enable );
   void setItalic ( bool enable );
   void setKerning ( bool enable );
   void setOverline ( bool enable );
   void setPixelSize ( int pixelSize );
   void setPointSize ( int pointSize );
   void setPointSizeF ( qreal pointSize );
   void setRawMode ( bool enable );
   void setRawName ( const QString & name );
   void setStretch ( int factor );
   void setStrikeOut ( bool enable );
   void setStyle ( Style style );
   void setStyleHint ( StyleHint hint, StyleStrategy strategy = PreferDefault );
   void setStyleStrategy ( StyleStrategy s );
   void setUnderline ( bool enable );
   void setWeight ( int weight );



   bool bold () const{return QFont::bold();}
   //QString defaultFamily () const{return Family;}
   //bool exactMatch () const;
   QString family () const{return QFont::family();}
   bool fixedPitch () const{return QFont::fixedPitch();}
   //HFONT handle () const;
   //bool isCopyOf ( const QFont & f ) const;
   bool italic () const{return QFont::italic();}
   bool kerning () const{return QFont::kerning();}
   //QString key () const{return
   //QString lastResortFamily () const;
   //QString lastResortFont () const;
   bool overline () const{return QFont::overline();}
   int pixelSize () const{return QFont::pixelSize();}
   int pointSize () const{return QFont::pointSize();}
   qreal pointSizeF () const{return QFont::pointSizeF();}
   bool rawMode () const{return QFont::rawMode();}
   QString rawName () const{return QFont::rawName();}
   //QFont resolve ( const QFont & other ) const;
   int stretch () const{return QFont::stretch();}
   bool strikeOut () const{return QFont::strikeOut();}
   Style style () const{return QFont::style();}
   StyleHint styleHint () const{return QFont::styleHint();}
   StyleStrategy styleStrategy () const{return QFont::styleStrategy();}
   //QString toString () const;
   bool underline () const{return QFont::underline();}
   int weight () const{return QFont::weight();}
};

}
}

#endif
