/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGFRAME_H
#define GLAN_SERVERGFRAME_H

#include <GWidget.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GFrame : public GWidget
{
public:

   enum Shape {
      NoFrame     = 0,      // no frame
      Box         = 0x0001, // rectangular box
      Panel       = 0x0002, // rectangular panel
      WinPanel    = 0x0003, // rectangular panel (Windows)
      HLine       = 0x0004, // horizontal line
      VLine       = 0x0005, // vertical line
      StyledPanel = 0x0006  // rectangular panel depending on the GUI style
   };
   enum Shadow {
      Plain    = 0x0010, // plain line
      Raised   = 0x0020, // raised shadow effect
      Sunken   = 0x0030  // sunken shadow effect
   };

protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   Shadow   FrameShadow;
   Shape    FrameShape;
   int      FrameStyle;
   int      LineWidth;
   int      MidLineWidth;
   int      FrameWidth;

public:
   GFrame(GWidget*, Qt::WFlags f=0, const QString& uniqueid=QString::null, bool final=FINAL);
   ~GFrame();

   // void setFrameRect ( const QRect & );
   void setFrameShadow ( Shadow );
   void setFrameShape ( Shape );
   void setFrameStyle ( int style );
   void setLineWidth ( int );
   void setMidLineWidth ( int );


   int frameStyle () const{return FrameStyle;}
   int frameWidth () const{return FrameWidth;}
   int lineWidth () const{return LineWidth;}
   int midLineWidth () const{return MidLineWidth;}
};

}

}

#endif
