/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGGRIDLAYOUT_H
#define GLAN_SERVERGGRIDLAYOUT_H

#include <GLayout.h>
#include <GSpacerItem.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GGridLayout : public GLayout
{
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   GGridLayout(GWidget *parent=0, bool final=FINAL);
   ~GGridLayout();

   void addItem ( GSpacerItem* item, int row, int column, int rowSpan = 1, int columnSpan = 1, Qt::Alignment alignment = 0 );
   void addLayout ( GLayout * layout, int row, int column, Qt::Alignment alignment = 0 );
   void addLayout ( GLayout * layout, int row, int column, int rowSpan, int columnSpan,
                    Qt::Alignment alignment = 0 );
   void addWidget ( GWidget * widget, int row, int column, Qt::Alignment alignment = 0 );
   void addWidget ( GWidget * widget, int fromRow, int fromColumn, int rowSpan,
                    int columnSpan, Qt::Alignment alignment = 0 );
   //QRect cellRect ( int row, int column ) const;
   int columnCount () const;
   int columnMinimumWidth ( int column ) const;
   int columnStretch ( int column ) const;
   virtual Qt::Orientations expandingDirections () const;
   void getItemPosition ( int index, int * row, int * column, int * rowSpan,
                          int * columnSpan );
   virtual bool hasHeightForWidth () const;
   virtual int heightForWidth ( int w ) const;
   virtual void invalidate ();
   //virtual QSize maximumSize () const;
   //virtual QSize minimumSize () const;
   Qt::Corner originCorner () const;
   int rowCount () const;
   int rowMinimumHeight ( int row ) const;
   int rowStretch ( int row ) const;
   void setColumnMinimumWidth ( int column, int minSize );
   void setColumnStretch ( int column, int stretch );
   //virtual void setGeometry ( const QRect & rect );
   void setOriginCorner ( Qt::Corner corner );
   void setRowMinimumHeight ( int row, int minSize );
   void setRowStretch ( int row, int stretch );
   //virtual QSize sizeHint () const;

};

}

}

#endif
