/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGGROUPBOX_H
#define GLAN_SERVERGGROUPBOX_H

#include <GWidget.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GGroupBox : public GWidget
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   Qt::Alignment  BoxAlignment;
   bool           CheckableFlag;
   bool           Checked;
   bool           Flat;
   QString        Title;
public:
   GGroupBox(GWidget*, bool final=FINAL);
   GGroupBox(const QString&, GWidget*, bool final=FINAL);
   ~GGroupBox();

   void setAlignment (Qt::Alignment);
   void setCheckable ( bool b );
   void setFlat ( bool b );
   void setTitle ( const QString & );

   Qt::Alignment alignment () const {return BoxAlignment;}
   bool isCheckable () const        {return CheckableFlag;}
   bool isChecked () const          {return Checked;}
   bool isFlat () const             {return Flat;}
   QString title () const           {return Title;}
public slots:
   void setChecked ( bool b );
};

}

}

#endif
