/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGLABEL_H
#define GLAN_SERVERGLABEL_H

#include <GFrame.h>
#include <GPixmap.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GLabel : public GFrame
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   Qt::Alignment  LabelAlignment;
   bool           LabelScaledContents;
   int            LabelIndent;
   int            LabelMargin;
   QString        LabelText;
   Qt::TextFormat LabelTextFormat;
   bool           LabelWordWrap;
   GWidget        *LabelBuddyWidget;
   GPixmap        *LabelPixmap;
public:
   GLabel(GWidget* parent=0, Qt::WFlags f=0, bool final=FINAL);
   GLabel(const QString&, GWidget* parent=0, Qt::WFlags f=0, bool final=FINAL);
   ~GLabel();


   void setAlignment ( Qt::Alignment );
   void setBuddy ( GWidget * buddy );
   void setIndent ( int );
   void setMargin ( int );
   void setScaledContents ( bool );
   void setTextFormat ( Qt::TextFormat );
   void setWordWrap ( bool on );


   Qt::Alignment alignment () const{return LabelAlignment;}
   GWidget * buddy () const{return LabelBuddyWidget;}
   bool hasScaledContents () const{return LabelScaledContents;}
   int indent () const{return LabelIndent;}
   int margin () const{return LabelMargin;}
   //QMovie * movie () const;
   //const QPicture * picture () const;
   const GPixmap * pixmap () const{return LabelPixmap;}
   QString text () const{return LabelText;}
   Qt::TextFormat textFormat () const{return LabelTextFormat;}
   bool wordWrap () const{return LabelWordWrap;}

public slots:
   void clear ();
   //void setMovie ( QMovie * movie );
   void setNum ( int num );
   void setNum ( double num );
   //void setPicture ( const QPicture & picture );
   void setPixmap ( const GPixmap & );
   void setText ( const QString & )   ;
};

}

}

#endif
