/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGLAYOUT_H
#define GLAN_SERVERGLAYOUT_H

#include <GObject.h>
#include <GWidget.h>

namespace Glan
{
namespace Server
{


/**
@author Oleg Shalnev
*/
class GLayout : public GObject
{
protected:
   int      Spacing;
   int      Margin;
   GWidget  *ParentWidget;

   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   GLayout(GWidget* parent=0, bool final=FINAL);
   ~GLayout();

   void setSpacing(int);
   void setMargin(int);
   void setMenuBar ( GWidget * widget );

   int spacing(){return Spacing;}
   int margin(){return Margin;}

   friend class GWidget;
};

}

}

#endif
