/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGLISTWIDGET_H
#define GLAN_SERVERGLISTWIDGET_H

#include <GListView.h>

namespace Glan
{
namespace Server
{
class GListWidgetItem;

/**
@author Oleg Shalnev
*/
class GListWidget : public GListView
{
    Q_OBJECT
protected:
    void initObject();
    virtual void processEvent(const QXmlAttributes&);
public:
    GListWidget(GWidget* parent, bool final=FINAL);
    ~GListWidget();

signals:
    void currentItemChanged ( GListWidgetItem * current, GListWidgetItem * previous );
    void currentRowChanged ( int currentRow );
    void currentTextChanged ( const QString & currentText );
    void itemActivated ( GListWidgetItem * item );
    void itemChanged ( GListWidgetItem * item );
    void itemClicked ( GListWidgetItem * item );
    void itemDoubleClicked ( GListWidgetItem * item );
    void itemEntered ( GListWidgetItem * item );
    void itemPressed ( GListWidgetItem * item );
    void itemSelectionChanged ();

};

}

}

#endif
