/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGLISTWIDGETITEM_H
#define GLAN_SERVERGLISTWIDGETITEM_H

#include <GObject.h>
#include <QPointer>
#include <GColor.h>
#include <QVariant>
#include <QHash>
#include <GFont.h>
#include <GIcon.h>


namespace Glan
{
namespace Server
{

class GListWidget;

/**
@author Oleg Shalnev
*/
class GListWidgetItem : public GObject
{
   Q_OBJECT
   QPointer<GListWidget>   ListWidget;
   int                     ItemAlignment;
   int                     ItemType;
   GColor                  ItemTextColor;
   GColor                  ItemBackgroundColor;
   //  QVariant                ItemData;
   QString                 ItemText;
   QString                 ItemToolTip;
   QString                 ItemStatusTip;
   QString                 ItemWhatsThis;
   Qt::ItemFlags           Flags;
   GFont                   ItemFont;
   GIcon                   ItemIcon;
   QHash<int, QVariant>    RoleData;
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   GListWidgetItem(GListWidget*, int type=0, bool final=FINAL);
   ~GListWidgetItem();


   //virtual void read ( QDataStream & in );
   //virtual void write ( QDataStream & out ) const;
   virtual void setBackgroundColor ( const GColor & color );
   //void setCheckState ( Qt::CheckState state );
   virtual void setData ( int role, const QVariant & value ){RoleData.insert(role, value);}
   void setFlags ( Qt::ItemFlags flags );
   void setFont (const  GFont& font );
   void setIcon (const  GIcon& icon );
   void setStatusTip ( const QString & statusTip );
   void setText ( const QString & text );
   void setTextAlignment ( int alignment=Qt::AlignHCenter );
   void setTextColor ( const GColor & color );
   void setToolTip ( const QString & toolTip );
   void setWhatsThis ( const QString & whatsThis );

   QString statusTip () const{return ItemStatusTip;}
   QString text () const{return ItemText;}
   int textAlignment () const{return ItemAlignment;}
   GColor textColor () const{return ItemTextColor;}
   QString toolTip () const{return ItemToolTip;}
   //int type () const;
   QString whatsThis () const{return ItemWhatsThis;}
   GColor backgroundColor () const{return ItemBackgroundColor;}
   //Qt::CheckState checkState () const;
   // virtual QListWidgetItem * clone () const;
   virtual QVariant data ( int role ) const{return RoleData.value(role);}
   Qt::ItemFlags flags () const{return Flags;}
   GFont font () {return ItemFont;}
   GIcon icon () {return ItemIcon;}
   //QListWidget * listWidget () const;
   void Activate(){emit activated();}
signals:
   void activated();
};

}

}

#endif
