/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGMAINWINDOW_H
#define GLAN_SERVERGMAINWINDOW_H

#include <GWidget.h>

namespace Glan
{
namespace Server
{
class GMenu;
class GMenuBar;
class GToolBar;
class GDockWidget;
/**
@author Oleg Shalnev
*/
class GMainWindow : public GWidget
{
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   GWidget  *CentralWidget;
   GMenuBar *MenuBar;
   bool     MenuBarCreated;
public:
   GMainWindow(GWidget* parent=0, Qt::WFlags f=0, const QString& uniqueId=QString::null, bool final=FINAL);
   ~GMainWindow();

   void addDockWidget ( Qt::DockWidgetArea area, GDockWidget * dockwidget );
   void addDockWidget ( Qt::DockWidgetArea area, GDockWidget * dockwidget,
                        Qt::Orientation orientation );
   //    void addToolBar ( Qt::ToolBarArea area, QToolBar * toolbar );
   void addToolBar ( GToolBar * toolbar );
   //    QToolBar * addToolBar ( const QString & title );
   //    void addToolBarBreak ( Qt::ToolBarArea area = Qt::TopToolBarArea );
   //    virtual QMenu * createPopupMenu ();
   //    void insertToolBar ( QToolBar * before, QToolBar * toolbar );
   //    void insertToolBarBreak ( QToolBar * before );
   //    void removeDockWidget ( QDockWidget * dockwidget );
   //    void removeToolBar ( QToolBar * toolbar );
   //    bool restoreState ( const QByteArray & state, int version = 0 );
   void setCentralWidget ( GWidget * widget );
   //    void setCorner ( Qt::Corner corner, Qt::DockWidgetArea area );
   //    void setIconSize ( const QSize & iconSize );
   void setMenuBar ( GMenuBar * menuBar );
   //    void setStatusBar ( QStatusBar * statusbar );
   //    void setToolButtonStyle ( Qt::ToolButtonStyle toolButtonStyle );
   //    void splitDockWidget ( QDockWidget * first, QDockWidget * second,
   //                           Qt::Orientation orientation );
   //

   GWidget * centralWidget () const{return CentralWidget;}
   //    Qt::DockWidgetArea corner ( Qt::Corner corner ) const;
   //    Qt::DockWidgetArea dockWidgetArea ( QDockWidget * dockwidget ) const;
   //    QSize iconSize () const;
   GMenuBar * menuBar ();
   //    QByteArray saveState ( int version = 0 ) const;
   //    QStatusBar * statusBar () const;
   //    Qt::ToolBarArea toolBarArea ( QToolBar * toolbar ) const;
   //    Qt::ToolButtonStyle toolButtonStyle () const;
   virtual void closeEvent(){}}
;

}

}

#endif
