/***************************************************************************
 *   Copyright (c) 2004-2005, Oleg Shalnev                                 *
 *   Copyright (c) 2005, OLMAX                                            *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGMENU_H
#define GLAN_SERVERGMENU_H

#include <GWidget.h>

namespace Glan
{
namespace Server
{

class GAction;
class GIcon;

/**
@author Oleg Shalnev
*/
class GMenu : public GWidget
{
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   QString MenuTitle;
   GAction *MenuAction;
   bool     inModal;
public:
   GMenu(GWidget*, bool final=FINAL);
   GMenu( const QString & title, GWidget*, bool final=FINAL);
   ~GMenu();

   void setTitle(const QString&);
   GAction* addAction ( const QString & text );
   GAction* addAction ( const QString & text, const GObject * receiver,
                        const char * member );
   void     addAction(GAction* action){GWidget::addAction(action);}
   GAction* addMenu ( GMenu * menu );
   GMenu*   addMenu ( const QString & title );
   GMenu*   addMenu ( const GIcon & icon, const QString & title );
   GAction* addSeparator ();
   void     clear ();
   GAction* insertMenu ( GAction * before, GMenu * menu );
   void     setIcon( const GIcon & icon );
   void exec();
   void exec(const QPoint&);

   QString  title(){return MenuTitle;}
   GAction* menuAction(){return MenuAction;}
};

}
}

#endif
