/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGOBJECT_H
#define GLAN_SERVERGOBJECT_H

#include <QObject>
#include <QXmlAttributes>
#include <GlanSimpleXML.h>

#define FINAL     true
#define NOT_FINAL false


namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GObject : public QObject
{
 //  Q_OBJECT
   quint64  ObjectId;
   const QString  ObjectUniqueId;

   Q_PROPERTY(QString ObjectUniqueId   READ getUniqueID);
protected:
   bool     rdelete;

   void initObject();
   void deleteObject();
   virtual void processEvent(const QXmlAttributes&);
   void prepareEvent(SimpleXmlElement&);
   void setClientObjectElement(GObject*, SimpleXmlElement&, const QString&);
public:
   GObject(GObject* parent=0, const QString& uniqueId=QString::null, bool final=FINAL);
   GObject(const GObject&);
   const GObject&operator=(const GObject&);
   ~GObject();

   void connect(GObject*, const char*, const QObject*, const char*, Qt::ConnectionType type = Qt::AutoCompatConnection );
   void rconnect(GObject*, const char*, GObject*, const char*);

   quint64   getObjectId(){return ObjectId;}
   QString   getUniqueID(){return ObjectUniqueId;}

   friend class GlanServerApplication;
   friend class GServer;
};

}

}

#endif
