/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGPALETTE_H
#define GLAN_SERVERGPALETTE_H

#include <GObject.h>
#include <QPalette>
#include <GColor.h>
#include <GBrush.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GPalette : public GObject, public QPalette
{
protected:
   void createPaletteFromColor(const GColor&);

   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   GPalette(GObject *parent=0, bool final=FINAL );
   GPalette ( const GColor & button,GObject *parent=0, bool final=FINAL  );
   GPalette ( Qt::GlobalColor button,GObject *parent=0,bool final=FINAL  );
   GPalette ( const GColor & button, const GColor & background,GObject *parent=0, bool final=FINAL  );
   GPalette ( const GBrush & foreground, const GBrush & button, const GBrush & light,
              const GBrush & dark, const GBrush & mid, const GBrush & text,
              const GBrush & bright_text, const GBrush & base, const GBrush & background,
              GObject *parent=0,bool final=FINAL  );
   //QPalette ( const QPalette & p );
   const GPalette& operator=(const GPalette&);
   ~GPalette();

   void setBrush ( ColorRole cr, const GBrush & brush );
   void setBrush ( ColorGroup cg, ColorRole cr, const GBrush & b );
   void setColor ( ColorGroup gr, ColorRole r, const GColor & c );
   void setColor ( ColorRole r, const GColor & c );
   void setColorGroup ( ColorGroup cg, const GBrush & foreground, const GBrush & button,
                        const GBrush & light, const GBrush & dark, const GBrush & mid,
                        const GBrush & text, const GBrush & bright_text, const GBrush & base,
                        const GBrush & background );
   void setCurrentColorGroup ( ColorGroup cg );
};

}
}

#endif
