/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGSTACKWIDGET_H
#define GLAN_SERVERGSTACKWIDGET_H

#include <GFrame.h>
#include <QList>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GStackedWidget : public GFrame
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   QList<GWidget*>   WidgetList;
   int               CurrentIndex;
public:
   GStackedWidget(GWidget*, bool final=FINAL);
   ~GStackedWidget();

   int addWidget ( GWidget * widget );
   int insertWidget ( int index, GWidget * widget );
   void removeWidget ( GWidget * widget );

   GWidget * widget ( int index ) const{return WidgetList.at(index);}
   int count () const                  {return WidgetList.count();}
   int currentIndex () const           {return CurrentIndex;}
   GWidget * currentWidget () const    {return WidgetList.at(CurrentIndex);}
   int indexOf(GWidget * widget ) const{return WidgetList.indexOf(widget);}

public slots:
   void setCurrentIndex ( int index );
   void setCurrentWidget ( GWidget * w );
signals:
   void currentChanged ( int index );
   void widgetRemoved ( int index );
};

}

}

#endif
