/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTABLEVIEW_H
#define GLAN_SERVERGTABLEVIEW_H

#include <GAbstractItemView.h>
#include <GHeaderView.h>
#include <QHash>
#include <QPointer>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GTableView : public GAbstractItemView
{
   Q_OBJECT

   bool                    ShowGridFlag;
   QHash<int, bool>        HideColumns;
   QHash<int, bool>        HideRows;
   Qt::PenStyle            ViewPenStyle;
   QPointer<GHeaderView>   HorizontalHeader;
   QPointer<GHeaderView>   VerticalHeader;
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);
public:
   GTableView(GWidget*, bool final=FINAL);
   ~GTableView();
   void setColumnHidden ( int column, bool hide );
   void setGridStyle ( Qt::PenStyle style );
   void setHorizontalHeader ( GHeaderView * header );
   void setRowHidden ( int row, bool hide );
   void setShowGrid ( bool show );
   void setVerticalHeader ( GHeaderView * header );
   bool showGrid () const;

public slots:
   void hideColumn ( int column );
   void hideRow ( int row );
   void resizeColumnToContents ( int column );
   void resizeRowToContents ( int row );
   void selectColumn ( int column );
   void selectRow ( int row );
   void showColumn ( int column );
   void showRow ( int row );
   void sortByColumn ( int column );
};

}
}

#endif
