/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTEXTEDIT_H
#define GLAN_SERVERGTEXTEDIT_H

#include <GAbstractScrollArea.h>

namespace Glan
{
namespace Server
{

class GFont;
/**
@author Oleg Shalnev
*/
class GTextEdit : public GAbstractScrollArea
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

public:

   GTextEdit(GWidget*, bool final=FINAL);
   ~GTextEdit();

public slots:
   void clear ();
   void copy ();
   void cut ();
   void insertHtml ( const QString & text );
   void insertPlainText ( const QString & text );
   void paste ();
   void scrollToAnchor ( const QString & name );
   void selectAll ();
   void setAlignment ( Qt::Alignment a );
   void setCurrentFont ( const GFont & f );
   void setFontFamily ( const QString & fontFamily );
   void setFontItalic ( bool italic );
   void setFontPointSize ( qreal s );
   void setFontUnderline ( bool underline );
   void setFontWeight ( int w );
   void setHtml ( const QString & text );
   void setPlainText ( const QString & text );
//   void setTextColor ( const QColor & c );
   void zoomIn ( int range = 1 );
   void zoomOut ( int range = 1 );

};

}
}

#endif
