/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTOOLBAR_H
#define GLAN_SERVERGTOOLBAR_H

#include <GWidget.h>
#include <GAction.h>
#include <GIcon.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GToolBar : public GWidget
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   bool                 MovableFlag;
   Qt::ToolBarAreas     Areas;
   QSize                Size;
   Qt::ToolButtonStyle  ButtonStyle;
   Qt::Orientation      Orientation;
public:
   GToolBar(GWidget* parent=0, bool final=FINAL);
   GToolBar(const QString&, GWidget* parent=0, bool final=FINAL);
   ~GToolBar();

   void addAction(GAction*);
   GAction * addAction ( const QString & text );
   GAction * addAction ( const GIcon icon, const QString& text );
   GAction * addAction ( const QString& text, const GObject* receiver, const char* member);
   GAction * addAction ( const GIcon icon, const QString& text, const GObject* receiver,
                         const char* member );
   GAction * addSeparator ();
   //GAction * addWidget ( QWidget * widget );
   void clear ();
   GAction * insertSeparator (GAction* before );
//   GAction * insertWidget ( GAction * before, GWidget * widget );
   void setAllowedAreas ( Qt::ToolBarArea areas );
   void setMovable ( bool movable );
   void setOrientation ( Qt::Orientation orientation );


   //QAction * toggleViewAction () const;
   Qt::ToolButtonStyle toolButtonStyle () const {return ButtonStyle;}
   QSize iconSize () const                      {return Size;}
   bool isMovable () const                      {return MovableFlag;}
   Qt::Orientation orientation () const         {return Orientation;}
   //bool isAreaAllowed ( Qt::ToolBarArea area ) const;
   Qt::ToolBarAreas allowedAreas () const       {return Areas;}
   
public slots:
   void setIconSize ( const QSize & iconSize );
   void setToolButtonStyle ( Qt::ToolButtonStyle toolButtonStyle );

signals:
   void actionTriggered ( GAction * action );
   void allowedAreasChanged ( Qt::ToolBarAreas allowedAreas );
   void iconSizeChanged ( const QSize & iconSize );
   void movableChanged ( bool movable );
   void orientationChanged ( Qt::Orientation orientation );
   void toolButtonStyleChanged ( Qt::ToolButtonStyle toolButtonStyle );
};

}
}

#endif
