/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTOOLBOX_H
#define GLAN_SERVERGTOOLBOX_H

#include <GFrame.h>
#include <GIcon.h>
#include <QList>
#include <QHash>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GToolBox : public GFrame
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   QList<GWidget*>          WidgetList;
  // QHash<GWidget*, GIcon*>  Icons;
   QHash<GWidget*, QString> Strings;
   QHash<GWidget*, QString> ToolTips;
   int                      CurrentIndex;
public:
   GToolBox(GWidget*, bool final=FINAL);
   ~GToolBox();
   int addItem ( GWidget * widget, const GIcon & iconSet, const QString & text );
   int addItem ( GWidget * w, const QString & text );
   int insertItem ( int index, GWidget * widget, const GIcon & icon, const QString & text );
   int insertItem ( int index, GWidget * widget, const QString & text );
   void removeItem ( int index );
   void setItemEnabled ( int index, bool enabled );
   void setItemIcon ( int index, const GIcon & icon );
   void setItemText ( int index, const QString & text );
   void setItemToolTip ( int index, const QString & toolTip );



   int count () const{return WidgetList.count();}
   int currentIndex () const{return CurrentIndex;}
   GWidget * currentWidget () const{return WidgetList.at(CurrentIndex);}
   int indexOf ( GWidget * widget ) const{return WidgetList.indexOf(widget);}
   bool isItemEnabled ( int index ) const;
   //GIcon itemIcon ( int index ) const{return *Icons.value(WidgetList.at(index));}
   QString itemText ( int index ) const{return Strings.value(WidgetList.at(index));}
   QString itemToolTip ( int index ) const{return Strings.value(WidgetList.at(index));}
   GWidget * widget ( int index ) const{return WidgetList.at(index);}

public slots:
   void setCurrentIndex ( int index );
   void setCurrentWidget ( GWidget * widget );
};

}
}

#endif
