/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTOOLBUTTON_H
#define GLAN_SERVERGTOOLBUTTON_H

#include <GAbstractButton.h>
#include <GMenu.h>
#include <GAction.h>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GToolButton : public GAbstractButton
{
   Q_OBJECT
public:
   enum ToolButtonPopupMode {
      DelayedPopup,
      MenuButtonPopup,
      InstantPopup
   };

protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   Qt::ArrowType        ButtonsArrowType;
   Qt::ToolButtonStyle  ButtonsStyle;
   ToolButtonPopupMode  PopupMode;
   bool                 AutoRise;
   GMenu                *ButtonsMenu;
   GAction              *ButtonsAction;
   
public:
   GToolButton(GWidget*, bool final=FINAL);
   ~GToolButton();

   void setArrowType ( Qt::ArrowType type );
   void setAutoRaise ( bool enable );
   void setMenu ( GMenu * menu );
   void setPopupMode ( ToolButtonPopupMode mode );

   Qt::ArrowType arrowType () const             {return ButtonsArrowType;}
   bool autoRaise () const                      {return AutoRise;}
   GAction * defaultAction () const             {return ButtonsAction;}
   GMenu * menu () const                        {return ButtonsMenu;}
   ToolButtonPopupMode popupMode () const       {return PopupMode;}
   Qt::ToolButtonStyle toolButtonStyle () const {return ButtonsStyle;}

public slots:
   void setDefaultAction ( GAction * action );
   void setToolButtonStyle ( Qt::ToolButtonStyle style );
   //void showMenu ();
};

}
}

#endif
