/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTREEVIEW_H
#define GLAN_SERVERGTREEVIEW_H

#include <GAbstractItemView.h>
#include <GHeaderView.h>
#include <QPointer>
#include <QHash>

namespace Glan
{
namespace Server
{

/**
@author Oleg Shalnev
*/
class GTreeView : public GAbstractItemView
{
   Q_OBJECT
protected:
   void initObject();
   virtual void processEvent(const QXmlAttributes&);

   QPointer<GHeaderView>   TreeViewHeader;
   QHash<int, bool>        HideColumn;
   int                     Identation;
public:
   GTreeView(GWidget*, bool final=FINAL);
   ~GTreeView();

   void setColumnHidden ( int column, bool hide );
   //void setExpanded ( const QModelIndex & index, bool expanded );
   void setHeader ( GHeaderView * header );
   void setIndentation ( int i );
   void setItemsExpandable ( bool enable );
   void setRootIsDecorated ( bool show );
   //void setRowHidden ( int row, const QModelIndex & parent, bool hide );
   void setUniformRowHeights ( bool uniform );

public slots:
   //void collapse ( const QModelIndex & index );
   //void expand ( const QModelIndex & index );
   void hideColumn ( int column );
   void resizeColumnToContents ( int column );
   virtual void selectAll ();
   void showColumn ( int column );
   void sortByColumn ( int column );
   void hideHeader();
signals:
   //void collapsed ( const QModelIndex & index );
   //void expanded ( const QModelIndex & index );
};

}

}

#endif
