/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_SERVERGTREEWIDGET_H
#define GLAN_SERVERGTREEWIDGET_H

#include <GTreeView.h>
#include <QStringList>


namespace Glan
{
namespace Server
{
class GTreeWidgetItem;

/**
@author Oleg Shalnev
*/
class GTreeWidget : public GTreeView
{
    Q_OBJECT
protected:

	GTreeWidgetItem *CurrentItem;

    int ColumnCount;
    void initObject();
    virtual void processEvent(const QXmlAttributes&);


public:
    GTreeWidget(GWidget*, bool final=FINAL);
    ~GTreeWidget();
    void setHeaderLabels ( const QStringList & labels );
    void setColumnCount ( int columns );
    void setCurrentItem ( GTreeWidgetItem * item );
    void setHeaderItem ( GTreeWidgetItem * item );
    void setItemExpanded ( GTreeWidgetItem * item, bool expand );
    void setItemHidden ( const GTreeWidgetItem * item, bool hide );
    void setItemSelected ( const GTreeWidgetItem * item, bool select );
    void setSortingEnabled ( bool enable );
    void sortItems ( int column, Qt::SortOrder order );

    int columnCount()const
    {
        return ColumnCount;
    }
public slots:
    void clear ();
    void collapseItem ( GTreeWidgetItem * item );
    void expandItem ( GTreeWidgetItem * item );
    //void scrollToItem ( const GTreeWidgetItem * item, QAbstractItemView::ScrollHint hint = EnsureVisible );
	GTreeWidgetItem* currentItem ();
	void obtain();
signals:
    void currentItemChanged ( GTreeWidgetItem * current, GTreeWidgetItem * previous );
    void itemActivated ( GTreeWidgetItem * item, int column );
    void itemChanged ( GTreeWidgetItem * item, int column );
    void itemClicked ( GTreeWidgetItem * item, int column );
    void itemCollapsed ( GTreeWidgetItem * item );
    void itemDoubleClicked ( GTreeWidgetItem * item, int column );
    void itemEntered ( GTreeWidgetItem * item, int column );
    void itemExpanded ( GTreeWidgetItem * item );
    void itemPressed ( GTreeWidgetItem * item, int column );
    void itemSelectionChanged ();
};

}
}

#endif
