/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                             *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_CLIENTGLANCLIENTABSTRACTITEMVIEW_H
#define GLAN_CLIENTGLANCLIENTABSTRACTITEMVIEW_H

#include <QAbstractItemView>
#include <GlanClientAbstractItemViewBase.h>
#include <GlanClientWidget.h>

namespace Glan
{
namespace Client
{

/**
@author Oleg Shalnev
*/
class GlanClientAbstractItemView : public QAbstractItemView
{
   Q_OBJECT
   GlanClientAbstractItemViewBase AbstractItemViewBase;
public:
   GlanClientAbstractItemView(const quint64 ObjectId, GlanClientWidget*);
   ~GlanClientAbstractItemView();

   QRect visualRect(const QModelIndex &index) const{return QRect(0,0,0,0);}
   void scrollTo(const QModelIndex &index, ScrollHint hint = EnsureVisible){}
   QModelIndex indexAt(const QPoint &p) const{QModelIndex ret;return ret;}
   QModelIndex moveCursor(CursorAction cursorAction,
                          Qt::KeyboardModifiers modifiers){QModelIndex ret;return ret;}

   int horizontalOffset() const{return 0;}
   int verticalOffset() const{return 0;}

   bool isIndexHidden(const QModelIndex &index) const{return false;}
   void setSelection(const QRect &rect, QItemSelectionModel::SelectionFlags command){}
   QRegion visualRegionForSelection(const QItemSelection &selection) const
      {return QRegion();}


public slots:
   bool processEvent(const QXmlAttributes& event)
   {
      AbstractItemViewBase.processEvent(event);
      return true;
   }
};

}
}

#endif
