/***************************************************************************
 *   Copyright (c) 2004-2005 Oleg Shalnev                                  *
 *   Copyright (c) 2005 OLMAX                                              *
 *   All rights reserved.                                                  *
 *   kalpa@yandex.ru                                                       *
 *   http://kalpa.sf.net                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GLAN_CLIENTGLANCLIENTTREEWIDGETBASE_H
#define GLAN_CLIENTGLANCLIENTTREEWIDGETBASE_H

#include <GlanClientTreeViewBase.h>
#include <QTreeWidgetItem>

namespace Glan
{
namespace Client
{

/**
@author Oleg Shalnev
*/
class GlanClientTreeWidgetBase : public GlanClientTreeViewBase
{
    Q_OBJECT
public:
    GlanClientTreeWidgetBase();
    ~GlanClientTreeWidgetBase();
    void processEvent(const QXmlAttributes&);
public slots:
    void currentItemChanged ( QTreeWidgetItem * current, QTreeWidgetItem * previous );
    void itemActivated ( QTreeWidgetItem * item, int column );
    void itemChanged ( QTreeWidgetItem * item, int column );
    void itemClicked ( QTreeWidgetItem * item, int column );
    void itemCollapsed ( QTreeWidgetItem * item );
    void itemDoubleClicked ( QTreeWidgetItem * item, int column );
    void itemEntered ( QTreeWidgetItem * item, int column );
    void itemExpanded ( QTreeWidgetItem * item );
    void itemPressed ( QTreeWidgetItem * item, int column );
    void itemSelectionChanged ();
};

}
}

#endif
