/**************************************************************************
 *** Project Kalpa.                                                     ***
 *** Copyright (c) 2005, Oleg Shalnev. Project Kalpa                    ***
 *** All rights reserved.                                               ***
 ***                                                                    ***
 *** mailto:glan@users.sf.net                                           ***
 *** mailto:kalpa@yandex.ru                                             ***
 *** http://kalpa.sf.net                                                ***
 ***                                                                    ***
 *************************************************************************/
#ifndef __GLAN_LIB_SIMPLE_XML_H__
#define __GLAN_LIB_SIMPLE_XML_H__
#include <qstring.h>

namespace Glan{
class SimpleXmlElement;

class SimpleXmlDocument
{
    QString Header;
    QString Document;
public:
    SimpleXmlDocument();
    ~ SimpleXmlDocument();
    const SimpleXmlDocument& operator=(const SimpleXmlDocument&);
    //    void setTitle(const QString&);
    void appendChild(SimpleXmlElement&);
    QString toString();
    void clean()
    {
        Header.truncate(0);
        Document.truncate(0);
    }
};

class SimpleXmlElement
{
    bool contentFlag;
    QString Header;
    QString Content;
    QString Footer;
    QString TitleString;
public:
    SimpleXmlElement();
    SimpleXmlElement(const QString&);
    const SimpleXmlElement& operator=(const SimpleXmlElement&);
    void setTitle(const QString&);
    void setAttribute(const QString&, const QString&);
    void setAttribute(const QString&, const QByteArray&);
    void setAttribute(const QString& name, const int attribute)
    {
        setAttribute(name, QString::number(attribute));
    }
    void setAttribute(const QString& name, const unsigned int attribute)
    {
       setAttribute(name, QString::number(attribute));
    }   
    void setAttribute(const QString& name, const double attribute)
    {
       setAttribute(name, QString::number(attribute));
    }
    void setAttribute(const QString& name, const quint64 attribute)
    {
       setAttribute(name, QString::number(attribute));
    }      
    void appendChild(SimpleXmlElement&);
    QString toString();
    QString* getContent()
    {
        return &Content;
    }
    void clean()
    {
        Header.truncate(0);
        Content.truncate(0);
        Footer.truncate(0);
        setTitle(TitleString);
    }
};

}
#endif
